import { Component, ViewEncapsulation } from '@angular/core';

@Component({
  selector: 'ej-app',
  templateUrl: 'src/treeview/treeview.component.html',
  styleUrls: ['src/treeview/treeview.component.css'],
  encapsulation: ViewEncapsulation.None,
})
export class TreeViewComponent { 
	localData: Array<any>;
    mainMenuViewFields: Object;
    htmlAttr: Object;
    treeViewContext: Array<any>;
    constructor() {
        this.treeViewContext = [
            { id: "201", text: "Add New Item" },
            { id: "202", text: "Remove Item" },
            { id: "203", text: "Disable Item" },
            { id: "204", text: "Enable Item" }
        ]
		this.localData = [
            { id: 1, name: 'Discover Music', hasChild: true, isBold: true, expanded: true },
            { id: 2, pid: 1, name: 'Hot Singles', isBold: true, expanded: true },
            { id: 3, pid: 2, name: 'Rising Artists' },
            { id: 4, pid: 2, name: 'Live Music', isBold: true },
            { id: 6, pid: 2, name: 'Best of 2013 So Far' },
            { id: 7, pid: 1, name: 'Sales and Events', hasChild: true },
            { id: 8, pid: 7, name: '100 Albums - $5 Each' },
            { id: 9, pid: 7, name: 'Hip-Hop and R&B Sale' },
            { id: 10, pid: 7, name: 'CD Deals' },
            { id: 11, name: 'Categories', hasChild: true, expanded: true },
            { id: 12, pid: 11, name: 'Songs' },
            { id: 13, pid: 11, name: 'Bestselling Albums' },
            { id: 14, pid: 11, name: 'New Releases', isBold: true },
            { id: 15, pid: 11, name: 'Bestselling Songs' },
            { id: 16, name: 'MP3 Albums', hasChild: true },
            { id: 17, pid: 16, name: 'Rock' },
            { id: 18, pid: 16, name: 'Gospel' },
            { id: 19, pid: 16, name: 'Latin Music' },
            { id: 20, pid: 16, name: 'Jazz' },
            { id: 21, name: 'More in Music', hasChild: true },
            { id: 22, pid: 21, name: 'Music Trade-In' },
            { id: 23, pid: 21, name: 'Redeem a Gift Card' },
            { id: 24, pid: 21, name: 'Band T-Shirts', isBold: true },
            { id: 25, pid: 21, name: 'Mobile MVC' }
        ];
        for (var i = 0; i < this.localData.length; i++) {
            if (this.localData[i].isBold) {
                this.localData[i].htmlAttr = { class: "bold" };
            }
            else {
                this.localData[i].htmlAttr = { class: "nonbold" };
            }
        }
        this.mainMenuViewFields = { id: 'id', parentId: 'pid', text: 'name', hasChild: 'hasChild', dataSource: this.localData, expanded: 'expanded', htmlAttribute: 'htmlAttr'};
	}
	onready (args) {
		$("#contextMenu").ejMenu({            
            menuType: ej.MenuType.ContextMenu,
            openOnClick: false,
            contextMenuTarget: "#mainMenuView",
            fields: { dataSource: this.treeViewContext, id: "id", text: "text", imageUrl: "imageUrl" },
            beforeOpen: function (args) {
                if ($(args.target).hasClass('e-text')) {
                    //identify the bold TreeView node
                    if ($(args.target).closest(".e-item").hasClass("bold")) {
                        this.hideItems(["#202", "#203", "#204"]);
                    }
                    else {
                        this.showItems(["#202", "#203", "#204"]);
                    }
                }
                else
                    args.cancel = true; // prevent to open the Context Menu other than the TreeView node
            }
        });
	}
}

		